﻿# Python-Skript erstellt einen Index eines Textes der über
# eine Auszeichnungssprache formatiert ist. Lesen Sie mehr
# zu dem Syntax in dem Beispiel jomtext.mto
#
# Copyright (c) 2012 Joachim Mailänder www.und-weiter.de
# Stand: 28.03.2012 (für Veröffentlichung aus Projekt entnommen)
#
import re

# Beispiel-Textdatei 
infile = r"E:\homepage\cms_2012\jomtext.txt"
index = r"E:\homepage\cms_2012\jomtext-index.txt"

# test=1: Index wird in Python-Shell ausgegeben
# test=0: Index wird in Datei 'index' ausgegeben
test = 0

# count=1: Zähler für Hauptüberschriften ausgeben
count = 0

def ReadFile(filename):
  dfile = open(filename, "r")
  s = dfile.read()
  return s

# Ausgabezeile aus der laufenden Nummer und der Überschrift zusammensetzen.
def crtl(no, caption):
  if count == 1:
    if no > 0:
      return str(no) + ": " + caption + "\n"
    else:
      return "  " + caption + "\n"
  else:
    return caption + "\n"

def ScanText(text):
  it = re.finditer(r"==(.*?) (.*?) ==", text, re.I)
  no = 0
  ret = ""
  for m in it:
    part = m.group(1)
    l = len(part)
    if l > 0:
      if part[0] != "=":
        no += 1
        ret += crtl(no, part + " " + m.group(2))
      else:
        blanks = l * " "
        ret += crtl(0, blanks + m.group(2))
    else:
      no += 1
      ret += crtl(no, m.group(2))
  return ret

def SaveIndex(mylist, filename):
  dfile = open(filename, "w")
  dfile.write(mylist)
  dfile.close()

def Main():
  txt = ReadFile(infile)
  lst = ScanText(txt)
  if test == 1:
    print(lst)
  else:
    lst = "Index von: " + infile + "\n\n" + lst
    SaveIndex(lst, index)
    print("Erstellt: " + index)

Main()

  
